
#include "stdafx.h"

UINT __stdcall UpdateVisioConfigChangeID(MSIHANDLE hInstall)
{
	HRESULT hr = S_OK;
	UINT er = ERROR_SUCCESS;

	hr = WcaInitialize(hInstall, "UpdateVisioConfigChangeID");
	ExitOnFailure(hr, "Failed to initialize");

	WcaLog(LOGMSG_STANDARD, "Initialized.");

	HKEY key = NULL;
	hr = HRESULT_FROM_WIN32(RegOpenKeyEx(HKEY_LOCAL_MACHINE, L"Software\\Microsoft\\Office\\Visio", 0, KEY_READ|KEY_WRITE, &key));
	ExitOnFailure(hr, "Failed to open the registry key: Software\\Microsoft\\Office\\Visio");

	WcaLog(LOGMSG_STANDARD, "Successfully opened registry key: Software\\Microsoft\\Office\\Visio");

	DWORD config_change_id = 1;
	DWORD config_change_id_len = sizeof(config_change_id);
	DWORD key_type = REG_DWORD;
	hr = HRESULT_FROM_WIN32(RegQueryValueEx(key, L"ConfigChangeID", NULL, &key_type, (LPBYTE)&config_change_id, &config_change_id_len));
	ExitOnFailure(hr, "Failed read old ConfigChangeID key value");

	WcaLog(LOGMSG_STANDARD, "Successfully read old ConfigChangeID value (%d)", config_change_id);

	++config_change_id;

	hr = HRESULT_FROM_WIN32(RegSetValueEx(key, L"ConfigChangeID", NULL, key_type, (LPBYTE)&config_change_id, config_change_id_len));
	ExitOnFailure(hr, "Failed set new ConfigChangeID key value");

	WcaLog(LOGMSG_STANDARD, "Successfully set new ConfigChangeID value (%d)", config_change_id);

LExit:
	er = SUCCEEDED(hr) ? ERROR_SUCCESS : ERROR_INSTALL_FAILURE;
	return WcaFinalize(er);
}


// DllMain - Initialize and cleanup WiX custom action utils.
extern "C" BOOL WINAPI DllMain(
	__in HINSTANCE hInst,
	__in ULONG ulReason,
	__in LPVOID
	)
{
	switch(ulReason)
	{
	case DLL_PROCESS_ATTACH:
		WcaGlobalInitialize(hInst);
		break;

	case DLL_PROCESS_DETACH:
		WcaGlobalFinalize();
		break;
	}

	return TRUE;
}
